'
' Experimental Amicus18 integer only PID routine Demonstration
' Written by Les Johnson (14-11-11)
' 
' Connect a potentiometer to AN0 to give as the required value (0 to 1023)
' Connect the output from CCP1 to AN1 through a low pass filter
'
' Turning the pot connected to AN0, the output of the PWM should match it
' Note that the PID routine will require tuning by adjusting P gain, I gain and D gain
'
    Declare Optimiser_Level = 3                 ' Maximum optimisation        
    Declare Dead_Code_Remove = On               ' Squeeze the code a bit more
    
    Include "ADC.inc"                           ' Load the ADC macros into the program
    Include "HPWM10.inc"                        ' Load the 10-bit HPWM macros into the program
    Include "PID.inc"                           ' Load the PID routine into the program
'
' Create some user variables
'    
    Dim MyInput As Word                         ' Input to the PID, which is the output from the sensor
    Dim MyRequired As Word                      ' The value required by the PID
    Dim MyOutput As Word                        ' The outut from the PID
    
'------------------------------------------------------------------------
' The main program loop starts here
'
Main:
'
' Open the ADC for 10-bit reading of AN0 and AN1
'
    OpenADC(ADC_FOSC_RC & ADC_RIGHT_JUST & ADC_2_TAD, ADC_REF_VDD_VSS, ADC_2ANA)
'
' Open the CCP1 channel for 10-bit PWM output
'
    OpenAnalog1()
'
' Setup the PID parameters
' (pKP, pKI, pKD, pMaxCorrection, pMaxError, pMinOutput, pMaxOutput)
'    
    PID_Setup(22, 7, 2, 1, 1, 0, 1023)
'
' Create a loop to constantly adjust the PWM (CCP1) output depending on the ADC (AN1) input
'
    While 1 = 1
        MyRequired = ReadADC(ADC_CH0)               ' Read the value required by the PID from AN0
        MyInput = ReadADC(ADC_CH1)                  ' Read AN1 for the value to place into the PID
        PID_Compute(MyInput, MyRequired, MyOutput)  ' Compute PID
        WriteAnalog1(MyOutput)                      ' Place the output of the PID onto the HPWM
        DelayMS 1                                   ' A small delay
    Wend                                            ' Do it forever

